#!/usr/bin/perl 


#┌─────────────────────────────────
#│ Psth表示ソフト v1.00 (2022/11/4)
#| update2023/11/14
#│ Copyright (c) Dotmatrix
#│ info@cgishop.net
#│ https://cgishop.net/
#└─────────────────────────────────
$version = 'Psth表示ソフト v1.00';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このスクリプトは、フリーソフトです。このスクリプトを使用した
#│    いかなる損害に対して作者は、一切の責任を負いません。
#│ 2. 直接メールによる質問は、お受けいたしておりません。
#│    
#│ 3. 送信フォームのHTMLページの作成に関しては、創作自由です。
#│    スクリプトは、よく勉強してから改造してください。
#│ 4. 良いご意見が有ればHPで受け付けます。
#│    前向きに検討し、今後の参考とさせていただきます。
#└─────────────────────────────────

#
#  [ 設置例 ]
#
#  desktop / pathview.pl (実行権限）[755]
#                  
#

#-------------------------------------------------
#  ▼基本設定
#-------------------------------------------------
use Tk;
use utf8;
use Tk::DirTree;
use Tk::FileSelect;
use Encode qw(decode);
use Tk::TextUndo;


#--------------------------------------------メインwindow------------------------------------------------------
$top = MainWindow->new;
#メインウィンドウのタイトル
$top->title("Psth表示ソフト ");
$top->optionAdd( '*font' => 'ＭＳゴシック 10');
  
  
#-----------------------------------menu-------------------------------------

# メニューバーを作る
$menu = $top->Menu(-type => "menubar");
#メニューバーの設定
$top->configure(-menu => $menu, -width => 300, -height => 100);

# [File]メニューを作る
$menu1 = $menu->cascade(-label => 'File', -under => 0, -tearoff => 0);
$menu1->command(-label => 'クリア', -under => 0, -command => \&clear);
$menu1->separator;
$menu1->command(-label => 'Exit', -under => 0, -command => \&onExit);

# [View]メニューを作る
$menu2 = $menu->cascade(-label => 'View', -under => 0, -tearoff => 0);
$menu2->command(-label => 'Readme', -under => 0, -command => \&onReadme );
$menu2->command(-label => 'hirano', -under => 0, -command => \&onHirano);

#----------------------------------スクロールバー付きリストボックス方向にoをつけると自動になるosoeow
$lis1 = $top->Scrolled('DirTree',
		    -directory => '/',
		    -background=> 'white',
		    -foreground =>'darkblue',
		    -scrollbars=> 'osoe',
                    -height => 30,
                    -width  => 30,
                    -indent =>20,
                    -selectforeground => 'brown',
                    -selectbackground => 'gray',
                    -browsecmd => \&dir)
  ->pack(-side=>'left',-fill=>'both',-expand => 'yes');
  
  
  
  
  sub dir{  
	$file1 = shift ;
	$utext -> delete('1.0' , 'end');
	$file = decode('utf8',$file1);
	$utext -> insert('1.0' , $file);  }
  
  
  
#------------------------表示ラベル------------------------------------------------------
 
$top -> Label(-textvariable => \$file,
		-background =>'white',
		-foreground =>'sienna',
		-borderwidth =>2,
		-padx =>20,
		-anchor =>'w',
		-relief =>'ridge'
		)-> pack( -side   => 'top',-anchor=>'w');
		
 #-------------------------テキスト表示ラベル-------------------------------------

$utext = $top -> Scrolled('TextUndo',
			-background =>'white',
			-width      => 50,
			-height     => 25,
			-wrap       => 'word',
			-scrollbars => 'se');
$utext -> pack( -side   => 'left',
		-fill   => 'both',
		-expand =>'yes');
 
#-----------------------select　ボタン------------------------------------------------------
#----------フレームセット---------------

$f1 = $top->Frame()->pack(-anchor=>"w");


#----------ボタン---------------

$f1->Button(-fg  => 'blue',-font     => ['','10','bold'],-text=> "FileSelect",-command=> \&fileselection)     ->pack(-side=>'top',-anchor =>'w');
$f1->Button(-text=> "copy",-command  => \&copy)                                                               ->pack(-side=>'top',-anchor =>'w');
$f1->Button(-text=> "クリア",-command => \&clear)                                                              ->pack(-side=>'top',-anchor =>'w');
$f1->Button(-text=> "終　了",-command => \&onExit)                                                             ->pack(-side=>'top',-anchor =>'w');

#-----------------------関数------------------------------------------------------
#----------ファイルセレクト関数---------------
sub fileselection{

$fsel = $top  -> FileSelect(-directory => $ENV{HOME});
$file = $fsel -> Show;
$txt  = $file;
    $top   -> clipboardClear; 
    $top   -> clipboardAppend('--', $txt ); 
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $txt);

}

#ヒアドキュメント
sub onReadme{

$txt = <<'EOS';

apt-getでperlTkをインストール
apt-get install perl-tk
CPANでinstallTkをしてからお使いください
cpan 
install  Tk
途中なにか聞かれたらｙで大丈夫です
参考URL
https://cgishop.jp/2022/08/09/perl-tk/


EOS

   
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $txt);
    
}
# 終了
sub onExit {
    exit;  
};


#著作権表示
sub onHirano{

$txt = <<'EOS';

<Copyright>

Shigemitsu Hirano

hirano@cgishop.net

https://cgishop.net
今後ともよろしくお願いします

EOS

    
    $utext -> delete('1.0' , 'end');
    $utext -> insert('1.0' , $txt);
   
}

#----------テキストボックスコピー関数---------------
sub copy {
    $txtbox = $utext -> get('1.0' , 'end');
    $top -> clipboardClear; 
    $top -> clipboardAppend('--', $txtbox ); 
     
    
};



#----------クリア関数---------------
sub clear{
     
     $utext -> delete('1.0' , 'end');
};
#----------終了関数---------------
sub onExit {
    exit;  
};

MainLoop;


#---
# pathview.pl
